'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactWeui = require('react-weui');

var _reactWeui2 = _interopRequireDefault(_reactWeui);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

require('weui');

var ButtonArea = _reactWeui2['default'].ButtonArea;
var Button = _reactWeui2['default'].Button;
var Cells = _reactWeui2['default'].Cells;
var CellsTitle = _reactWeui2['default'].CellsTitle;
var CellsTips = _reactWeui2['default'].CellsTips;
var Cell = _reactWeui2['default'].Cell;
var CellHeader = _reactWeui2['default'].CellHeader;
var CellBody = _reactWeui2['default'].CellBody;
var CellFooter = _reactWeui2['default'].CellFooter;

var WeForm = (function (_Component) {
  _inherits(WeForm, _Component);

  _createClass(WeForm, null, [{
    key: 'propTypes',
    value: {
      schema: _react2['default'].PropTypes.array.isRequired,
      form: _react2['default'].PropTypes.object.isRequired
    },
    enumerable: true
  }, {
    key: 'defaultProps',
    value: {
      schema: {},
      form: {}
    },
    enumerable: true
  }]);

  function WeForm(props) {
    _classCallCheck(this, WeForm);

    _get(Object.getPrototypeOf(WeForm.prototype), 'constructor', this).call(this, props);
    this.state = {
      values: {},
      errors: {},
      langs: {},
      form: {}
    };
    this.renderForm = this.renderForm.bind(this);
    this.renderActions = this.renderActions.bind(this);
    this.setItemValue = this.setItemValue.bind(this);
  }

  _createClass(WeForm, [{
    key: 'trans',
    value: function trans(key) {
      var translation = this.state.langs[this.state.form.locale];
      if (translation && translation[key]) {
        var phase = translation[key];
        var needle = '{s}';
        var count = phase.split(needle).length - 1;

        if (count < 1) return phase;

        for (var _len = arguments.length, vars = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          vars[_key - 1] = arguments[_key];
        }

        for (var i = 0; i <= count - 1; i++) {
          if (typeof vars[i] !== undefined) phase = phase.replace(needle, vars[i]);
        };

        return phase;
      } else {
        console.log('Warning: missing translation for: ' + key);
        return key;
      }
    }
  }, {
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.setState({ form: Object.assign({}, defaultForm, this.props.form) });
      this.setState({ langs: Object.assign({}, defaultLangs, this.props.form) });
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var defaults = {};
      this.props.schema.forEach(function (section, index) {
        var items = section.properties;
        items.map(function (item, i) {
          if (item['default']) {
            defaults[item.id] = item['default'];
          }
        });
      });

      this.setState({ values: defaults });
    }
  }, {
    key: 'setItemValue',
    value: function setItemValue(field, value) {
      var _values = Object.assign({}, this.state.values, _defineProperty({}, field, value));
      this.setState({ values: _values });
    }
  }, {
    key: 'itemOnChange',
    value: function itemOnChange(type, id, e) {
      switch (type) {
        case 'checkbox':
          this.setItemValue(id, e.target.checked);
          break;
        default:
          this.setItemValue(id, e.target.value);
          break;
      }
    }
  }, {
    key: 'getErrorStyle',
    value: function getErrorStyle(field, sectionIndex) {
      if (this.state.errors === {}) return false;
      if (typeof this.state.errors[sectionIndex] === 'undefined') return false;
      if (this.state.errors[sectionIndex][field]) {
        return 'weui_cell_warn';
      }
    }
  }, {
    key: 'getErrorsTitleStyle',
    value: function getErrorsTitleStyle(index) {
      if (this.state.errors === {}) return false;
      if (this.state.errors[index]) {
        if (Object.keys(this.state.errors[index]).length > 0) return true;
      }
      return false;
    }
  }, {
    key: 'renderItem',
    value: function renderItem(schema, sectionIndex) {
      var _this = this;

      return schema.map(function (item, i) {
        switch (item.type) {
          case 'text':
            return _react2['default'].createElement(
              Cell,
              { key: i, className: _this.getErrorStyle(item.id, sectionIndex) },
              _react2['default'].createElement(
                CellHeader,
                null,
                _react2['default'].createElement(
                  'label',
                  { className: 'weui_label' },
                  item.label
                )
              ),
              _react2['default'].createElement(
                CellBody,
                null,
                _react2['default'].createElement('input', { className: 'weui_input', type: 'text',
                  placeholder: item.placeholder, value: _this.state.values[item.id],
                  onChange: _this.itemOnChange.bind(_this, item.type, item.id) })
              ),
              _this.getErrorStyle(item.id, sectionIndex) ? _react2['default'].createElement(
                CellFooter,
                null,
                _react2['default'].createElement('i', { className: 'weui_icon_warn' })
              ) : false
            );
            break;
          case 'password':
            return _react2['default'].createElement(
              Cell,
              { key: i, className: _this.getErrorStyle(item.id, sectionIndex) },
              _react2['default'].createElement(
                CellHeader,
                null,
                _react2['default'].createElement(
                  'label',
                  { className: 'weui_label' },
                  item.label
                )
              ),
              _react2['default'].createElement(
                CellBody,
                null,
                _react2['default'].createElement('input', { className: 'weui_input', type: 'password',
                  placeholder: item.placeholder, value: _this.state.values[item.id],
                  onChange: _this.itemOnChange.bind(_this, item.type, item.id) })
              ),
              _this.getErrorStyle(item.id, sectionIndex) ? _react2['default'].createElement(
                CellFooter,
                null,
                _react2['default'].createElement('i', { className: 'weui_icon_warn' })
              ) : false
            );
            break;
          case 'number':
            return _react2['default'].createElement(
              Cell,
              { key: i, className: _this.getErrorStyle(item.id, sectionIndex) },
              _react2['default'].createElement(
                CellHeader,
                null,
                _react2['default'].createElement(
                  'label',
                  { className: 'weui_label' },
                  item.label
                )
              ),
              _react2['default'].createElement(
                CellBody,
                null,
                _react2['default'].createElement('input', { className: 'weui_input', type: 'number',
                  placeholder: item.placeholder, value: _this.state.values[item.id],
                  onChange: _this.itemOnChange.bind(_this, item.type, item.id) })
              ),
              _this.getErrorStyle(item.id, sectionIndex) ? _react2['default'].createElement(
                CellFooter,
                null,
                _react2['default'].createElement('i', { className: 'weui_icon_warn' })
              ) : false
            );
            break;
          case 'date':
            return _react2['default'].createElement(
              Cell,
              { key: i, className: _this.getErrorStyle(item.id, sectionIndex) },
              _react2['default'].createElement(
                CellHeader,
                null,
                _react2['default'].createElement(
                  'label',
                  { className: 'weui_label' },
                  item.label
                )
              ),
              _react2['default'].createElement(
                CellBody,
                null,
                _react2['default'].createElement('input', { className: 'weui_input', type: 'date',
                  placeholder: item.placeholder, value: _this.state.values[item.id],
                  onChange: _this.itemOnChange.bind(_this, item.type, item.id) })
              ),
              _this.getErrorStyle(item.id, sectionIndex) ? _react2['default'].createElement(
                CellFooter,
                null,
                _react2['default'].createElement('i', { className: 'weui_icon_warn' })
              ) : false
            );
            break;
          case 'datetime':
            return _react2['default'].createElement(
              Cell,
              { key: i, className: _this.getErrorStyle(item.id, sectionIndex) },
              _react2['default'].createElement(
                CellHeader,
                null,
                _react2['default'].createElement(
                  'label',
                  { className: 'weui_label' },
                  item.label
                )
              ),
              _react2['default'].createElement(
                CellBody,
                null,
                _react2['default'].createElement('input', { className: 'weui_input', type: 'datetime-local',
                  placeholder: item.placeholder, value: _this.state.values[item.id],
                  onChange: _this.itemOnChange.bind(_this, item.type, item.id) })
              ),
              _this.getErrorStyle(item.id, sectionIndex) ? _react2['default'].createElement(
                CellFooter,
                null,
                _react2['default'].createElement('i', { className: 'weui_icon_warn' })
              ) : false
            );
            break;
          case 'textarea':
            return _react2['default'].createElement(
              Cell,
              { key: i, className: _this.getErrorStyle(item.id, sectionIndex) },
              _react2['default'].createElement(
                CellBody,
                null,
                _react2['default'].createElement(
                  'textarea',
                  { className: 'weui_textarea', placeholder: item.placeholder,
                    rows: '3', onChange: _this.itemOnChange.bind(_this, item.type, item.id) },
                  _this.state.values[item.id]
                )
              )
            );
            break;
            break;
          case 'select':
            return _react2['default'].createElement(
              Cell,
              { key: i,
                className: (0, _classnames2['default'])('weui_cell_select', { weui_select_after: item.label }, _this.getErrorStyle(item.id, sectionIndex)) },
              item.label ? _react2['default'].createElement(
                CellHeader,
                null,
                item.label
              ) : false,
              _react2['default'].createElement(
                CellBody,
                null,
                _react2['default'].createElement(
                  'select',
                  { className: 'weui_select', value: _this.state.values[item.id],
                    onChange: _this.itemOnChange.bind(_this, item.type, item.id) },
                  item.options.map(function (option, j) {
                    return _react2['default'].createElement(
                      'option',
                      { value: option.value, key: j },
                      option.label
                    );
                  })
                )
              )
            );
            break;
          case 'checkbox':
            return _react2['default'].createElement(
              'label',
              { key: i, className: 'weui_cell weui_check_label' },
              _react2['default'].createElement(
                'div',
                { className: 'weui_cell_hd' },
                _react2['default'].createElement('input', { type: 'checkbox', className: 'weui_check', value: _this.state.values[item.id],
                  onClick: _this.itemOnChange.bind(_this, item.type, item.id) }),
                _react2['default'].createElement('i', { className: 'weui_icon_checked' })
              ),
              _react2['default'].createElement(
                'div',
                { className: 'weui_cell_bd weui_cell_primary' },
                _react2['default'].createElement(
                  'p',
                  null,
                  item.label
                )
              )
            );
            break;
        }
      });
    }
  }, {
    key: 'validateForm',
    value: function validateForm() {
      var _this2 = this;

      var error = false;
      var errors = [];
      var values = this.state.values;

      this.props.schema.forEach(function (section, index) {
        var items = section.properties;
        errors[index] = {};
        items.forEach(function (item, i) {
          if (!item.rule) return;

          var rules = item.rule.split('|');
          rules.forEach(function (rule) {
            if (errors[index][item.id]) return;
            var rulecmds = rule.split(':');
            var cmd = rulecmds[0];
            var params = typeof rulecmds[1] !== 'undefined' ? rulecmds[1].split(',') : false;
            switch (cmd) {
              case 'required':
                if (!values[item.id]) errors[index][item.id] = _this2.trans('required');
                break;
              case 'string':
                if (typeof values[item.id] !== 'string') errors[index][item.id] = _this2.trans('needstring');
                break;
              case 'number':
                if (typeof parseFloat(values[item.id]) !== 'number') errors[index][item.id] = _this2.trans('neednumber');
                break;
              case 'image':
                if (!values[item.id].name.match(/\.(jpg|jpeg|png|gif|svg)$/)) errors[index][item.id] = _this2.trans('needimage');
                break;
              case 'date':
              case 'datetime':
                var str = values[item.id];
                var ret = true;
                var valuedate = new Date(values[item.id]);
                if (!valuedate instanceof Date || isNaN(valuedate.valueOf())) ret = false;
                if (ret) {
                  if (typeof params[0] !== 'undefined') {
                    var minDate = new Date(params[0]).getTime();
                    if (valuedate < minDate) ret = false;
                  }
                  if (typeof params[1] !== 'undefined') {
                    var maxDate = new Date(params[1]).getTime();
                    if (valuedate > maxDate) ret = false;
                  }
                }
                if (!ret) errors[index][item.id] = _this2.trans('needdate');
                break;
              case 'between':
                if (typeof params[0] === 'undefined') break;
                if (values[item.id].length < params[0]) errors[index][item.id] = _this2.trans('needlength1', params[0]);
                if (typeof params[1] !== 'undefined') {
                  if (params[0] == 0 && values[item.id].length > params[1]) errors[index][item.id] = _this2.trans('needlength2', params[1]);
                  if (values[item.id].length > params[1]) errors[index][item.id] = _this2.trans('needlength3', params[0], params[1]);
                }
                break;
            }
          });
          if (errors[index][item.id]) error = true;
        });
      });
      if (error) return errors;
      return false;
    }
  }, {
    key: 'handleClick',
    value: function handleClick(onClick) {

      this.setState({ errors: {} });
      var errors = this.validateForm();
      console.log(errors);
      if (errors) {
        return this.setState({ errors: errors });
      } else {
        if (onClick) onClick(this.state.values);
      }
    }
  }, {
    key: 'renderForm',
    value: function renderForm() {
      var _this3 = this;

      return this.props.schema.map(function (sections, index) {
        var items = sections.properties;
        var styleTitle = {
          color: _this3.getErrorsTitleStyle(index) ? '#e64340' : '#888'
        };
        var className = (0, _classnames2['default'])({
          weui_cells: true,
          weui_cells_form: true,
          weui_cells_checkbox: sections.checkbox
        });
        return _react2['default'].createElement(
          'div',
          { key: index },
          sections.label ? _react2['default'].createElement(
            CellsTitle,
            { style: styleTitle },
            sections.label
          ) : false,
          _react2['default'].createElement(
            Cells,
            { className: className },
            _this3.renderItem(items, index)
          ),
          sections.tips ? _react2['default'].createElement(
            CellsTips,
            null,
            sections.tips
          ) : false
        );
      });
    }
  }, {
    key: 'renderActions',
    value: function renderActions() {
      var _this4 = this;

      return this.props.form.actions.map(function (action, index) {
        return _react2['default'].createElement(
          Button,
          { key: index, type: action.type, onClick: _this4.handleClick.bind(_this4, action.onClick) },
          action.label
        );
      });
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2['default'].createElement(
        'section',
        null,
        this.renderForm(),
        _react2['default'].createElement(
          ButtonArea,
          null,
          this.renderActions()
        )
      );
    }
  }]);

  return WeForm;
})(_react.Component);

;

var defaultLangs = {
  'en': {
    'required': 'Required',
    'needstring': 'Needs to be a valid string',
    'neednumber': 'Needs to be a valid number',
    'needimage': 'Needs to be a valid image',
    'needdate': 'Needs to be a valid date',
    'needdatetime': 'Needs to be a valid time',
    'needlength1': 'Length size needs to be bigger than {s}',
    'needlength2': 'Length size needs to be less than {s}',
    'needlength3': 'Length size needs to be between {s} and {s}'
  }
};

var defaultForm = {
  locale: 'en',
  actions: [{
    label: '提交',
    type: 'primary',
    onClick: function onClick(data) {
      return console.log(data);
    }
  }]
};

module.exports = WeForm;